/// Generated By XFlutter Cli.
///
/// more info: https://medium.com/@aghiadodeh
///
/// state managment for UI
///
/// store and manage your liveData in [LoginParams].
import 'package:easy_localization/easy_localization.dart';
import 'package:flutter_mvvm_example/extensions/formz_extensions.dart';
import 'package:flutter_mvvm_example/models/data/login_request/login_request_model.dart';
import 'package:flutter_mvvm_example/models/ui_models/ui_message.dart';
import 'package:flutter_mvvm_example/network/managers/authentication_manager.dart';
import 'package:flutter_mvvm_example/repositories/user_repository.dart';
import 'package:flutter_mvvm_example/ui/core/events/bus_events.dart';

import "login_params.dart";
import 'package:lazy_evaluation/lazy_evaluation.dart';

import 'package:flutterx_live_data/flutterx_live_data.dart';
import 'package:flutter_mvvm_example/models/forms/formz_email.dart';
import 'package:flutter_mvvm_example/models/forms/formz_password.dart';

class LoginViewModel {
  final _params = Lazy(() => LoginParams());
  LoginParams get params => _params.value;

  final _repository = Lazy(() => UserRepository());
  UserRepository get repository => _repository.value;

  /// update [LoginParams] some [FormzEmail] variable.
  void formzEmailChanged(MutableLiveData<FormzEmail> attr, String value) {
    final newValue = FormzEmail.dirty(value);
    attr.postValue(newValue);
  }

  /// update [LoginParams] some [FormzPassword] variable.
  void formzPasswordChanged(MutableLiveData<FormzPassword> attr, String value) {
    final newValue = FormzPassword.dirty(value);
    attr.postValue(newValue);
  }

  Future<void> login() async {
    eventBus.fire(const SoftKeyboardEvent());
    params.loading.postValue(true);
    final loginRequest = _mappingRequestModel();
    final response = await repository.login(loginRequest);
    if (response.success && response.data?.user != null && response.data?.token != null) {
      await AuthenticationManager.login(response.data!.user!, response.data!.token!);
      params.result.postValue(response.data!);
      params.loading.postValue(false);
    } else {
      params.loading.postValue(false);
      params.uiMessage.postValue(UiMessage(message: response.message ?? "error_try_again".tr()));
    }
  }

  /// convert [LoginParams.email] and [LoginParams.password] to [LoginRequest] model
  LoginRequest _mappingRequestModel() {
    return LoginRequest(
      params.email.inputValue(),
      params.password.inputValue(),
    );
  }
}
